
#ifndef _YS67F9XXX_H_
#define _YS67F9XXX_H_

#include "Typedef.h"

/*
(޸)ʱ:2022/04/27
//*/

/*******************************************/

/*˿0ݼĴ*/
sfr P0 = 0x80;

sfr SP = 0x81;
sfr DPL = 0x82;
sfr DPH = 0x83;

/*P0жѡĴ
 Ϊ1ӦP0 IOΪжϴԴ
*/
sfr P0SEL = 0x84;
#define P0SEL7 0x80
#define P0SEL6 0x40
#define P0SEL5 0x20
#define P0SEL4 0x10
#define P0SEL3 0x08
#define P0SEL2 0x04
#define P0SEL1 0x02
#define P0SEL0 0x01

/*WKSRC IOⲿжϻ
 b7-b2:NA

 b1(INT1WK):
	0ֻڴжλ£P0˿ڱ仯жԴܻMCU
	1ûʹжλ£P0˿ڱ仯жԴԻMCU

 b0(INT0WK):
	0ֻڴжλ£INT0жԴܻMCU
	1ûʹжλ£INT0жԴԻMCU

*/
sfr WKSRC = 0x85;

#define INT1WK 0x02
#define INT0WK 0x01

/*WDTCF
  WDTCFĶд忴ŹԤƵͼ

  b7-b3:NA

  b2-b0:WDTƵ
*/
sfr WDTCF = 0x86;
#define WDT_1 0X00
#define WDT_4 0X01
#define WDT_8 0X02
#define WDT_16 0X03
#define WDT_32 0X04
#define WDT_64 0X05
#define WDT_128 0X06
#define WDT_256 0X07

/*
PCON
b7 - b5 : ͨñ
b4 : ˯ʹ		DEEPMODE
b3 - b2 : ͨñ
b1 : ǳ˯ʹ			STOPMODE
b0 : ʹ			IDLEMODE
*/
sfr PCON = 0x87;
#define DEEPMODE 0X10
#define STOPMODE 0X02
#define IDLEMODE 0X01

/*TCON

  b7-b4: NA

  b3(IE1): IO(P0)жϱ־λֻ0

  b2: NA

  b1(IE0): INT0жϱλжϺ˳жӲԶ0Ҳ0

  b0(IT0): INT0½ؼѡ
  0: ½
  1: 
 */
sfr TCON = 0x88;
sbit IT0 = TCON ^ 0;
sbit IE0 = TCON ^ 1;

sbit IE1 = TCON ^ 3;

/*TMOD
 b7(GATE1):

 b6(IN1PL): ھⲿP04ϵĵƽǸЧǵЧ
  0: ͵ƽЧ
  1: ߵƽЧ

 b5(C/T1):T1ʱѡ
  0:ʱģʽ
  1:ģʽ

 b4(T1M): T1ģʽѡ
  0: ģʽ0 16bit
  1: ģʽ1 8bitԶ

 b3: NA

 b2(T1CM): T1 ʱģʽʱԴѡ
  0: T1ʹ÷ƵλSCA[1:0]ѡʱӼ
  1: T1ʹϵͳʱӼ

 b1(TF1): T1 λ
  жϺλԶ㣬Ҳ0

 b0(TR1): T1
*/
sfr TMOD = 0x89;
#define GATE1 0x80
#define IN1PL 0x40
#define T1_T 0x20
#define T1M 0X10

#define T1CM 0x04
#define TF1 0X02
#define TR1 0X01

/*TL1 T1ֽڼĴ*/
sfr TL1 = 0x8B;

/*TH1 T1ֽڼĴ*/
sfr TH1 = 0x8D;

/*CKCON
  b7(T4MH): T4ֽʱѡ
  0: T48λģʽ£T4ֽʹϵͳʱ
  1: T48λģʽ£T4ֽʹT4XCLKʱ

  b6(T4ML): T4ֽʱѡ
  0: T48λģʽ£T4ֽʹϵͳʱ
  1: T48λģʽ£T4ֽʹT4XCLKʱ

  b5(T3MH): T3ֽʱѡ
  0: T38λģʽ£T3ֽʹϵͳʱ
  1: T38λģʽ£T3ֽʹT3XCLKʱ

  b4(T3ML): T3ֽʱѡ
  0: T38λģʽ£T3ֽʹϵͳʱ
  1: T38λģʽ£T3ֽʹT3XCLKʱ

  b3(T2MH): T2ֽʱѡ
  0: T28λģʽ£T2ֽʹϵͳʱ
  1: T28λģʽ£T2ֽʹT2XCLKʱ

  b2(T2ML): T2ֽʱѡ
  0: T28λģʽ£T2ֽʹϵͳʱ
  1: T28λģʽ£T2ֽʹT2XCLKʱ

  b1-b0 (SCA)T1Ƶѡ
  00: ϵͳʱ4Ƶ(Ĭ)
  01: ϵͳʱ12Ƶ
  10: ϵͳʱ48Ƶ
  11: ⲿʱ8Ƶ
  */
sfr CKCON = 0x8E;
#define T4MH 0x80
#define T4ML 0x40
#define T3MH 0x20
#define T3ML 0x10
#define T2MH 0x08
#define T2ML 0x04
#define SCA_0 0x00
#define SCA_1 0x01
#define SCA_2 0x02
#define SCA_3 0x03

/*PSCTL ̿ƼĴ
 b7-b4:NA

 b3(FLA_VIO):̳־ɶд
	1ڶFLASHʱMOVXָĿַֿҳ0ڽһγɹ̲Ӳ0
	0ڶFLASHʱMOVXָĿַͬһ

 b2(FLA_ACT):ռĴλд1ʾʼFlasḥ
	д0ЧԶ0

 b1(FLA_SEC):ʹܣЧ

 b0(FLA_WEN):ʹܣЧ
	ֻFLA_WENΪʱFLA_SEC
*/
sfr PSCTL = 0x8F;
#define FLA_VIO 0X08
#define FLA_ACT 0X04
#define FLA_SEC 0X02
#define FLA_WEN 0X01

/*˿1ݼĴ*/
// sfr P1 = 0x90;

/*Timer2ؼĴ,PPGģʽڼĴ*/
sfr16 TMR2RL = 0x91;

/*Timer2ؼĴֽ,PPGģʽڼĴֽ*/
sfr TMR2RLL = 0x91;

/*Timer2ؼĴֽڣPPGģʽڼĴֽ*/
sfr TMR2RLH = 0x92;

/*Timer2 PPGģʽռձ*/
sfr16 TMR2BL = 0x93;

/*Timer2 PPGģʽռձȵĵֽ*/
sfr TMR2BLL = 0x93;

/*Timer2 PPGģʽռձȵĸֽ*/
sfr TMR2BLH = 0x94;

/*ADC0CN
 b7(AD0EN):ADC0ʹ
	1'b0ADC0ʹܣ͹Ĺضϣ
	1'b1ADC0ʹܣʹ׼ʼת

 b6(BURSTEN):ADC0 Burst Mode Enable
	1'b0ADC0ͻģʽʹ
	1'b1ADC0ͻģʽʹ

 b5(AD0INT):ADC0תжϱ־
	ADתɣBURSTEN=0/1Ӳ1ɴжϣ

 b4(AD0BUSY):ADC0 Busy
	ADC0CM[1:0]=2'b00ADC0BUSYд1ADתд0ADC0
	bitADCǰ״̬
	1'b1ADC0 BUSY1'b0ADC0 IDLE

 b3-b2:NA

 b1-b0(AD0CM[1:0]):ADC0תģʽѡָADCתԴ
  00ADC0BUSYд1
  01Timer1Timer1 8bitģʽʱֽΪTimer1
  10Timer2Timer2 8bitģʽʱֽΪTimer1
  11Timer3Timer3 8bitģʽʱֽΪTimer1

*/
sfr ADC0CN = 0x95;
#define AD0EN 0x80
#define BURSTEN 0x40
#define AD0INT 0x20
#define AD0BUSY 0x10
#define AD0CM_ADC0BUSY 0x00
#define AD0CM_T1 0x01
#define AD0CM_T2 0x02
#define AD0CM_T3 0x03

/*ADC0CF
 b7-b3(AD0SC[4:0]):ADC0 SARתʱӷƵϵ
	BURSTEN=0FCLKǵǰϵͳʱ
	BURSTEN=1FCLK12MHz͹ʱӣڲʱӣϵͳʱ
	CLKSAR=FCLK/AD0SCAD0SC=1~31
	CLKSAR=FCLK/32AD0SC=0

 b2(AD08BE):ADC0 8bitģʽʹ
	1'b0ADC010bitģʽģʽ
	1'b1ADC08bitģʽ

 b1(AD0TM):ADC0ģʽ
	1'b0ģʽADC0ʹܣתźЧʼADת
	1'b1ӳٸģʽADC0ʹܣתźЧ3SARʱӲſʼADתӳٵʱADCи

 b0(AMP0GN):ADC0
	1'b0ƬPGAΪ1
	1'b1ƬPGAΪ0.5

*/
sfr ADC0CF = 0x96;
//#define AD0SC   		0xF8
#define AD08BE 0x04
#define AD0TM 0x02
#define AMP0GN 0x01

/*ADC0AC
 b7(AD012BE):ADC0 12bitģʽʹ
	1'b012bitģʽʹ
	1'b112bitģʽʹ
	עͬʱһ12bitģʽʹܣ
	112bitģʽʹ
	210bitģʽʹ
	3Burstģʽʹ
	4RepeatΪ4ıο½4.4˵

 b6(AD0AE):ADC0 ۼʹ
	ͻģʽʹܣʹܶתʵۼ
	1'b0ADC0H:ADC0LΪתĽ
	1'b1ADC0H:ADC0LΪۼתĽд0x0000
	ADC0H:ADC0Lۼӽ

 b5-b3(AD0SJST[2:0]):ADC0ۼλͶ뷽ʽ
	ָʾADC0H:ADC0Lصݸʽ
	3'b000Ҷ룻ûλ
	3'b001Ҷ룻1λ
	3'b010Ҷ룻2λ
	3'b011Ҷ룬3λ
	3'b100룻ûλ
	Ҷ룻ûλ
	עظ1Ҷ룻AD08BE=1'b1롣

 b2-b0(AD0RPT[2:0]):ADC0ظ
	ѡͻģʽתۼӴͻģʽʹܣAD0RPT
	Ϊ3'b000/3'b110/3'b111
	3'b0001
	3'b0014
	3'b0108
	3'b01116
	3'b10032
	3'b10164
	1

*/
sfr ADC0AC = 0x97;
#define AD012BE 0x80
#define AD0AE 0x40

#define AD0SJST_R_0 0x00
#define AD0SJST_R_1 0x08
#define AD0SJST_R_2 0x10
#define AD0SJST_R_3 0x18
#define AD0SJST_L 0x20

#define AD0RPT_1 0x00
#define AD0RPT_4 0x01
#define AD0RPT_8 0x02
#define AD0RPT_16 0x03
#define AD0RPT_32 0x04
#define AD0RPT_64 0x05

/*
SCON:

  b7(S0MODE):UARTģʽѡ
  0:8bit UART MODE
  1:9bit UART MODE

  b6(TX_EN):UARTʹ

  b5(MCE0):ദͨѶʹܡ
	8λUARTģʽڼϷֹͣλ
	0ֹͣλ
	1ֹͣλΪ1ʱRI0Ч
	9λUARTģʽദͨѶʹ
	0Եھλݡܵھλ01գжϣ
	1ھλΪ1ʱRI01жϡھλ0ᶪǰѽյֽݣµȴһֽڵĿʼ

  b4(RX_EN):1ʹUART

   b3(TB80):9bit UARTģʽҪ͵ĵ9λ

  b2(RB80):9bit UARTģʽ½յĵ9λ

  b1(TI0):UARTжϱ־,

  b0(RI0):UARTжϱ־,
*/
sfr SCON = 0x98;
sbit RI0 = SCON ^ 0;
sbit TI0 = SCON ^ 1;
sbit RB80 = SCON ^ 2;
sbit TB80 = SCON ^ 3;
sbit RX_EN = SCON ^ 4;
sbit MCE0 = SCON ^ 5;
sbit TX_EN = SCON ^ 6;
sbit S0MODE = SCON ^ 7;

/*UARTݻ*/
sfr SBUF0 = 0x99;

/*
REF0CN ѹοƼĴ
  b7: NA

  b6(DEM_EN):ADC¶ʹܿ
	0ʹ
	1ʹ

  b5: 0

  b4(REFGND):ADC0οѡ
   0ADC0زοPAD1/GND pin
   1ADC0زοPAD48/AGND pin

  b3,b2(REFSL[1:0]):ADC0ѹοѡ
	00ADC0ѹοP1.0/VREF pin
	01ADC0ѹοVDD pin
	10ADC0ѹοڲ1.8Vֹѹ
	11ADC0ѹοڲѹο

  b1,b0(IREFSL[1:0]):ADC0ڲοѹѡ
	002V
	013V
	1x4V
*/
sfr REF0CN = 0x9F;

#define DEM_EN 0x40

#define REFGND 0x10

#define REF_VREF 0X00
#define REF_VDD 0X04
#define REF_18 0X08
#define REF_INT 0X0C

#define REF_INT_2V 0X00
#define REF_INT_3V 0X01
#define REF_INT_4V 0X02

/*˿2ݼĴ*/
sfr P2 = 0xA0;

/*SPICFG
 b7(SPIBSY):SPI 
	λSPIʱΪ1

 b6(MSTINT):ģʽʹλ
	0: ʹģʽڴӻģʽ
	1: ʹģʽģʽ

 b5(CKPHA):SPI ʱλѡ
	0: ݲλSCKڵĵһʱ
	1: ݲλSCKڵĵڶʱ

 b4(CKPOL):SPI ʱӼѡ
	0: sck ڲʱڵ͵ƽ
	1: sckڲʱڸߵƽ

 b3(SLVSEL):ӻѡ־λ
	λΪ1NSS pinΪʱʾӻSPIѡͨѶ󡣴λNSSǸߣӻûбѡʱᱻΪ0

 b2(NSSIN):NSS ʱʱ

 b1(SRMT):λĴձ־(ֻڴӻģʽʱЧ)

 b0(RXBMT):ݴձ־(ֻڴӻģʽʱЧ)

*/
sfr SPICFG = 0xA1;
#define SPIBSY 0x80
#define MSTINT 0x40
#define CKPHA 0x20
#define CKPOL 0x10
#define SLVSEL 0x08
#define NSSIN 0x04
#define SRMT 0x02
#define RXBMT 0x01

/*SPIʱʼĴ
  SPI ʱƵ = ϵͳʱƵ/(2*(SPISCR+1))*/
sfr SPISCR = 0xA2;

/*SPI ͺͽݼĴ*/
sfr SPIDAT = 0xA3;

/*ADC0PWR
 b7(AD0LPM):ADC0 ͹ģʽʹλ
	0:ʹ
	1:ʹ

 b6-b5:NA

 b4-b0(AD0PWR[4:0]):ADC0ͻģʽϵʱ = (AD0PWR+1)*8*84ns

*/
sfr ADC0PWR = 0xA5;
#define AD0LPM 0x80

/*ADC0TK
 b7-b6:NA

 b5-b0(AD0TK[5:0]):AD0ͻģʽʱ = (64-AD0TK)* 84ns

*/
sfr ADC0TK = 0xA6;

/*ADC0MX
 b7-b4:NA

 b3-b0(AD0MX[3-0]):ADͨѡ
	0000P1.4  ADCͨ0
	0001P1.5  ADCͨ1
	0010P3.4  ADCͨ2
	0011P3.5  ADCͨ3
	0100P2.0  ADCͨ4
	0101P2.1  ADCͨ5
	0110P2.2  ADCͨ6
	0111P2.3  ADCͨ7
	1000P2.4  ADCͨ8
	1001P2.5  ADCͨ9
	1010P2.6  ADCͨ10
	1011P2.7  ADCͨ11
	1100ضģʽԴѹ
	1101VDD
	1110Digital Supply VoltageVREG0 Output1.7V Typical
	1111Ground
*/
sfr ADC0MX = 0xA7;
#define ADC_CH0 0X00  /*P1.4*/
#define ADC_CH1 0X01  /*P1.5*/
#define ADC_CH2 0X02  /*P3.4*/
#define ADC_CH3 0X03  /*P3.5*/
#define ADC_CH4 0X04  /*P2.0*/
#define ADC_CH5 0X05  /*P2.1*/
#define ADC_CH6 0X06  /*P2.2*/
#define ADC_CH7 0X07  /*P2.3*/
#define ADC_CH8 0X08  /*P2.4*/
#define ADC_CH9 0X09  /*P2.5*/
#define ADC_CH10 0X0A /*P2.6*/
#define ADC_CH11 0X0B /*P2.7*/
#define ADC_CH_GND 0X0C
#define ADC_CH_17 0X0D
#define ADC_CH_VDD 0X0E	 /*VDD*/
#define ADC_CH_VDD0 0X0F /*ضģʽԴѹ*/

/*IE
 b7(EA):жܿ
   1:
   0:

  b6(EADC):ADCжλ

  b5(ESPI):SPIжλ

  b4(ES0):UARTжλ

  b3(ET1):T1жλ

  b2(EP0):P0˿жλ

  b1:NA

  b0(EX0):ⲿ(Int10)жλ
*/
sfr IE = 0xA8;
sbit EX0 = IE ^ 0;

sbit EP0 = IE ^ 2;
sbit ET1 = IE ^ 3;
sbit ES0 = IE ^ 4;
sbit ESPI = IE ^ 5;
sbit EADC = IE ^ 6;
sbit EA = IE ^ 7;

sfr16 ADC0 = 0xA9;

/*ADC0ֵֽ*/
sfr ADC0L = 0xA9;

/*ADC0ָֽ*/
sfr ADC0H = 0xAA;

/*ANA_CTRL
 b7-b3:NA

 b2(EXT_CP):VLCDѹģʽ
	0VLCDѹоƬڲCharge PumpṩĬֵ
	1VLCDѹƬṩ

 b1-b0(CPCK_CTL[1:0]):Charge PumpƵ
	00 8KHZ
	01 4KHZ
	10 2KHZ
	11 1KHZ
*/
sfr ANA_CTRL = 0xAF;
#define EXT_CP 0x04
#define CPCK_CTL_8k 0x00
#define CPCK_CTL_4k 0x01
#define CPCK_CTL_2k 0x02
#define CPCK_CTL_1k 0x03

/*˿3ݼĴ*/
sfr P3 = 0xB0;

/*TMR3CN
 b7(TF3H):Timer3ֽ־,Ҫ0

 b6(TF3L):Timer3ֽ־Ҫ0

 b5(TF3LEN):Timer3ֽжʹ

 b4(TF3H_OVF):Timer3ֽ־λ
	timer3ĸֽڴ0xFF0x00ʱӲԶ1㡣
	ֻcapture modeʱ˱־˱־жϡ

 b3(T3XCLK):Timer3ⲿʱѡ
	0ʱΪϵͳʱ12ƵץźΪʱ8Ƶ
	1ʱΪʱ8ƵץźΪⲿpinź

 b2(T3POL):Timer3 PPG PWNOUT ѡ
	0start  high
	1start  low

 b1-b0(T3MOD[1:0]):Timer3ģʽѡ
	00timer38λģʽ
	01timer3һ16λģʽ
	10timer3ץģʽ(16bit)
	11timer3PPGģʽ(16bit)
	עPPGģʽ£PWMʹùתʱPWMδP3[0]ʹùתʱP0[2]
*/
sfr TMR3CN = 0xB1;
#define TF3H 0x80
#define TF3L 0x40
#define TF3LEN 0x20
#define TF3H_OVF 0x10
#define T3XCLK 0x08
#define T3POL 0x04

#define T3_MODE_2_8 0X00
#define T3_MODE_16 0X01
#define T3_MODE_CAP 0X02
#define T3_MODE_PPG 0X03

/*TMR4CN
 b7(TF4H):Timer4ֽ־,Ҫ0

 b6(TF4L):Timer4ֽ־Ҫ0

 b5(TF4LEN):Timer4ֽжʹ

 b4(TF4H_OVF):Timer4ֽ־λ
	timer4ĸֽڴ0xFF0x00ʱӲԶ1㡣
	ֻcapture modeʱ˱־˱־жϡ

 b3(T4XCLK):Timer4ⲿʱѡ.
	0ʱΪϵͳʱ12ƵץźΪʱ8Ƶ
	1ʱΪʱ8ƵץźΪⲿpinź

 b2(T4POL):Timer4 PPG PWNOUT ѡ
	0start  high
	1start  low

 b1-b0(T4MOD[1:0]):Timer4ģʽѡ
	00timer48λģʽ
	01timer4һ16λģʽ
	10timer4ץģʽ(16bit)
	11timer4PPGģʽ(16bit)
	עPPGģʽ£PWMʹùתʱPWMδP3[1]ʹùתʱP0[3]
*/
sfr TMR4CN = 0xB2;
#define TF4H 0x80
#define TF4L 0x40
#define TF4LEN 0x20
#define TF4H_OVF 0x10
#define T4XCLK 0x08
#define T4POL 0x04

#define T4_MODE_2_8 0X00
#define T4_MODE_16 0X01
#define T4_MODE_CAP 0X02
#define T4_MODE_PPG 0X03

/*FLASH̿Ĵ
Ⱥ˳FLKEYд0xA50xF1"FLASH"


2λӳڲ״̬6λص0x00
00
010xA5Ѿд룬ȴ0xF1д
10
11

*/
sfr FLKEY = 0xB7;

/*
IP
 b7-b6:NA

 b5(PSPI):SPIжȼ

 b4(PS0):UARTжȼ

 b3(PT1):T1жȼ

 b2(PP0):P0˿жȼ

 b1:NA

 b0(PX0):ⲿ(Int0)жȼ
*/
sfr IP = 0xB8;
sbit PX0 = IP ^ 0;

sbit PP0 = IP ^ 2;
sbit PT1 = IP ^ 3;
sbit PS0 = IP ^ 4;
sbit PSPI = IP ^ 5;

/*
FCTR
 b7:NA

 b6(UARTOIR):
	ڿUartڷһ֡ݺǷݷͶ˿(TX)ԶΪ͡˹ڶദͨѶĳUartӻTXʼշ͸ߵƽӻ޷ݡ
	0Զת˿
	1Զת˿͡

 b5(TIMER4FTR):
	0TIMER4PPGܲת(P3.1)
	1TIMER4PPGת(P0.3)

 b4(TIMER3FTR):
	0TIMER3PPGܲת(P3.0)
	1TIMER3PPGת(P0.2)

 b3(TIMER2FTR):
	0TIMER2PPGܲת(P3.2)
	1TIMER2PPGת(P0.4)

 b2(UARTFTR):
	0Uartܲת(P3.2,P3.3)
	1Uartת(P0.2,P0.3)

 b1(SPIFTR):
	0SPIܲת(P3.0,P3.1,P3.2,P3.3)
	1SPIת(P0.4,P0.5,P0.6,P0.7)

 b0(I2CFTR):
	0I2Cܲת(P3.1,P3.0)
	1I2Cת(P0.0,P0.1)
*/
sfr FCTR = 0xB9;

#define UARTOIR 0x40
#define TIMER4FTR 0x20
#define TIMER3FTR 0x10
#define TIMER2FTR 0x08
#define UARTFTR 0x04
#define SPIFTR 0x02
#define I2CFTR 0x01

/*I2CݼĴ*/
sfr I2C_DIN = 0xBA;

/*I2CݼĴ*/
sfr I2C_DOUT = 0xBB;

/*I2Cӻַ*/
sfr I2C_SLAD = 0xBC;

/*I2C_STAT
  b0(STRETCH): ڵַƥ£I2Cÿֽڵĵ9λӲԶ1SCLǿͣΪд0ͷSCL

  b1(DATA): ǰݵַƥʱ/ֽӲ1

  b2(STOP): ַƥʱյSTOP

  b3(START): յƥĵַֽں1

  b4(NACK): աֽӦλ
			0: ACK
			1: NACK
  b5(I2CINT):
			0: b3-b1ȫΪ0
			1: b3-b1ȫΪ0
  b6(ACTIVE): ǰݵĵַƥʱΪ1
  b7(MDOD): 0: дģʽ
			1: ģʽ
		*/
sfr I2C_STAT = 0xBD;
#define DMOD 0x80
#define ACTIVE 0x40
#define I2CINT 0x20
#define NACK 0x10
#define START 0x08
#define STOP 0x04
#define DATA 0x02
#define STRETCH 0x01

/*
16λRTCĵֵֽ
16λRTCֵֽ
д16λRTCֵֽ
*/
sfr RTCL = 0xBE;

/*
16λRTCĸֵֽ
16λRTCֵֽ
д16λRTCֵֽ
*/
sfr RTCH = 0xBF;

/*
IRQ0
 b7(MCDIRQ):MCDжϱ־
   ֻеʱȱʧʧܰ0

 b6(I2CIRQ):I2Cжϱ־
	ֻ0

 b5(CSIRQ):ݴжϱ־
	ֻ0

 b4:NA

 b3(RTCIRQ):RTCжϱ־
	ֻ0

 b2-b0:NA
*/
sfr IRQ0 = 0xC0;

sbit RTCIRQ = IRQ0 ^ 3;

sbit CSIRQ = IRQ0 ^ 5;
sbit I2CIRQ = IRQ0 ^ 6;
sbit MCDIRQ = IRQ0 ^ 7;

/* P4˿ڷƼĴ 0 : Output  1 : Input */
sfr P4DIR = 0xC1;

/* P5˿ڷƼĴ 0 : Output  1 : Input */
sfr P5DIR = 0xC2;

/* P6˿ڷƼĴ 0 : Output  1 : Input */
sfr P6DIR = 0xC3;

/*P6˿ģģʽ(b5-b4) 0ģʽ 1ģģʽ */
sfr P6AN = 0xC5;

/* P6˿ʹλ 1 : enable */
sfr P6PU = 0xC6;

// sfr MCDST	 		= 0xC7;

/*
TMR2CN
 b7(TF2H):timer2ֽ־,Ҫ

 b6(TF2L):timer2ֽ־,Ҫ

 b5(TF2LEN):timer2ֽжʹ

 b4:NA

 b3(T2XCLK):timer2ⲿʱѡ
	0ʱΪϵͳʱ12Ƶ
	1ʱΪʱ8ƵʱCLKCF [4]

 b2(T2POL):timer2 PPG PWNOUT ѡ
	0start  high
	1start  low

 b1-b0(T2MOD[1:0]):timer2ģʽѡ
	00timer28λģʽ
	01timer2һ16λģʽ
	1xtimer2PPGģʽ(16bit)
	עPPGģʽ£PWMʹùתʱPWMδP3[2]ʹùתʱP0[4]
*/
sfr TMR2CN = 0xC8;
#define TF2H 0x80
#define TF2L 0x40
#define TF2LEN 0x20

#define T2XCLK 0x08
#define T2POL 0x04

#define T2_MODE_2_8 0X00
#define T2_MODE_16 0X01
#define T2_MODE_PPG 0X02

/*˿6ݼĴ*/
sfr P4 = 0xC9;

/*˿6ݼĴ*/
sfr P5 = 0xCA;

/*˿6ݼĴ*/
sfr P6 = 0xCB;

/*P3˿ģģʽ(b5-b4) 0ģʽ 1ģģʽ */
sfr P3AN = 0xCC;

/*P0˿ģģʽ 0ģʽ 1ģģʽ */
sfr P0AN = 0xCD;

/*P5˿ģģʽ 0ģʽ 1ģģʽ */
sfr P5AN = 0xCE;

/*P2˿ģģʽ 0ģʽ 1ģģʽ */
sfr P2AN = 0xCF;

sfr PSW = 0xD0;

/* P0˿ڷƼĴ 0 : Output  1 : Input */
sfr P0DIR = 0xD1;

/* P1˿ڷƼĴ 0 : Output  1 : Input */
sfr P1DIR = 0xD2;

/* P2˿ڷƼĴ 0 : Output  1 : Input */
sfr P2DIR = 0xD3;

/* P3˿ڷƼĴ(b5-b0) 0 : Output  1 : Input */
sfr P3DIR = 0xD4;

/* P0˿ʹλ 1 : enable */
sfr P0PU = 0xD5;

/* P5˿ʹλ 1 : enable */
sfr P5PU = 0xD6;

/*
PXC
 b7:ֻд0д1

 b6(HDRV):IOģʽIO
	0ģʽ
	1ǿģʽ

 b5(COMPU):P3[5:4]P4[7:0]P5[7:0]P6[7:0] ʹλ
	0ֹ
	1ʹ


 b3-b0(P3PU [3:0]):P3[3:0]˿ʹλP3PU[3:0]ֱӦP3[3:0]ʹܡ
	0ֹ
	1ʹ
*/
sfr PXC = 0xD7;

#define HDRV 0x40
#define COMPU 0x20

#define P3PU3 0x08
#define P3PU2 0x04
#define P3PU1 0x02
#define P3PU0 0x01

/*
EIP1
 b7(PMCD):MCDжȼ

 b6(PI2C):I2Cжȼ

 b5(PCS):жȼ

 b4(PT4):ʱ4жȼ

 b3(PRTC):RTCжȼ

 b2(PT3):ʱ3жȼ

 b1:NA

 b0(PT2):ʱ2жȼ
*/
sfr EIP1 = 0xD8;
sbit PT2 = EIP1 ^ 0;

sbit PT3 = EIP1 ^ 2;
sbit PRTC = EIP1 ^ 3;
sbit PT4 = EIP1 ^ 4;
sbit PCS = EIP1 ^ 5;
sbit PI2C = EIP1 ^ 6;
sbit PMCD = EIP1 ^ 7;

/* P4˿/ģģʽ 0:ģʽ 1:ģģʽ*/
sfr P4AN = 0xDD;

/* P4˿ʹλ 1 : enable*/
sfr P4PU = 0xDE;

/* P2˿ʹλ 1 : enable */
sfr P2PU = 0xDF;

sfr ACC = 0xE0;

/*Timer3ؼĴPPGģʽڼĴ*/
sfr16 TMR3RL = 0xE1;

/*Timer3ؼĴֽ,PPGģʽڼĴֽ*/
sfr TMR3RLL = 0xE1;

/*Timer3ؼĴֽڣPPGģʽڼĴֽ*/
sfr TMR3RLH = 0xE2;

/*Timer3 PPGģʽռձ*/
sfr16 TMR3BL = 0xE3;

/*Timer3 PPGģʽռձȵĵֽ*/
sfr TMR3BLL = 0xE3;

/*Timer3 PPGģʽռձȵĸֽ*/
sfr TMR3BLH = 0xE4;

/*Timer2 PPGģʽӳ*/
sfr TMR2DZ = 0xE5;

/*Timer3 PPGģʽӳ*/
sfr TMR3DZ = 0xE6;

/*Timer3 PPGģʽӳ*/
sfr TMR4DZ = 0xE7;

/*EIE1
  b7(EMCD): MCDжλ
  b6(EI2C): I2Cжλ
  b5(ECS): жλ
  b4(ET4): T4жλ
  b3(ERTC): RTCжλ
  b2(ET3): T3жλ
  b1: NA
  b0(ET2): T2жλ
  */
sfr EIE1 = 0xE8;
sbit ET2 = EIE1 ^ 0;

sbit ET3 = EIE1 ^ 2;
sbit ERTC = EIE1 ^ 3;
sbit ET4 = EIE1 ^ 4;
sbit ECS = EIE1 ^ 5;
sbit EI2C = EIE1 ^ 6;
sbit EMCD = EIE1 ^ 7;

/*
RSTEN
 b7-b4:NA

 b3(LVD_PD):LVDģλ
   0LVDģʹ
   1LVDģر

 b2(EOS_GATE):EOS¼ſʱӿλ
   1EOS¼ſʱӣ
   0ֹEOS¼ſʱ

 b1(EOS_RST_EN):EOSλ
   1EOSλ
   0ֹ

 b0(EOR_PD):BORģλ
   0BORģʹ
   1BORģر
*/
sfr RSTEN = 0xE9;
#define LVD_PD 0x08
#define EOS_GATE 0x04
#define EOS_RST_EN 0x02
#define EOR_PD 0x01

/*
CLKCF
 b7:NA

 b6(CK12M):ڲʱʹλЧ
   0ڲʱ
   1ڲʱ

 b5(FCK_EXT_EN):12MHzʱԴѡ
   1ѡⲿʱ
   0ѡڲʱ

 b4(SCK_EXT_EN):32KHzʱԴѡ
   1ѡⲿʱ
   0ѡڲʱ

 b3:NA

 b2(MCD_EN):MCDģ
   1ʹMCDģ飬MCD¼󷢳ж
   0ֹ

 b1(SYS_IND):ֻϵͳʱָʾλ,ڡʱлı־
   0ʾϵͳʱڲʱ
   1 ʾϵͳʱⲿʱ

 b0(CKSEL):ϵͳʱѡ
   0ѡʱ
   1ѡʱ
*/
sfr CLKCF = 0xEA;
#define CK12M 0x40
#define FCK_EXT_EN 0x20
#define SCK_EXT_EN 0x10
#define MCD_EN 0x04
#define SYS_IND 0x02
#define CKSEL 0x01

sfr CLKCF2 = 0xEB;

/*
RSTSRC (ֻĴ)
  b7(EXTR):1ʾⲿλ

  b6(EOSR):1ʾ˵Ӧλ

  b5(VDD_STAT):VDD״̬λ

  b4(FEDR):1ʾǰMOVXķǷ˸λ

  b3(WDTR):1ʾŹ˸λ

  b2(SOFTR):1ʾλ

  b1(POR):1ʾϵ縴λ

  b0(PWR_FAIL):1ʾ磬˸λ
*/
sfr RSTSRC = 0xEF;
#define EXTR 0x80
#define EOSR 0x40
#define VDD_STAT 0x20
#define FEDR 0x10
#define WDTR 0x08
#define SOFTR 0x04
#define POR 0x02
#define PWR_FAIL 0x01

sfr B = 0xF0;

/*Timer4ؼĴPPGģʽڼĴ*/
sfr16 TMR4RL = 0xF1;

/*Timer4ؼĴֽڣPPGģʽڼĴֽ*/
sfr TMR4RLL = 0xF1;

/*Timer4ؼĴֽڣPPGģʽڼĴֽ*/
sfr TMR4RLH = 0xF2;

/*Timer4 PPGģʽռձ*/
sfr16 TMR4BL = 0xF3;

/*Timer4 PPGģʽռձȵĵֽ*/
sfr TMR4BLL = 0xF3;

/*Timer4 PPGģʽռձȵĸֽ*/
sfr TMR4BLH = 0xF4;

/*
PER_EN
 b7(TOUTEN):I2C SCLʱʹʹλ
	1:ʹ

 b6:NA

 b5(RTC_SET):RTC TIMERʹܣRTCزӲԶ0
	1RTCʱؼֵ
	0RTCʱؼֵ


 b4(I2C_EN):I2Cģʹλ
	1ʹ
	0ֹ


 b3(RTC_EN):RTCʹλ
	1ʹ
	0ֹ


 b2(TMR4_EN):ʱ4ʹλ
	1ʹ
	0ֹ


 b1(TMR3_EN):ʱ3ʹλ
	1ʹ
	0ֹ


 b0(TMR2_EN):ʱ2ʹλ
	1ʹ
	0ֹ
*/
sfr PER_EN = 0xF6;
#define TOUTEN 0X80

#define RTC_SET 0X20
#define I2C_EN 0X10
#define RTC_EN 0X08
#define TMR4_EN 0X04
#define TMR3_EN 0X02
#define TMR2_EN 0X01

/*
SPICTL
 b7(SPIIF):SPI жϱ־λ

 b6(WCOL):SPIдͻ־λʾSPIݻûз꣬дSPIݣ

 b5(MODF):ģʽ־λ

 b4(RXOVRN):OVERRUN־(ֻдӻģʽЧ)

 b3-b2(NSSMD):ӻģʽѡ
	00:3ߴӷʽ3ʽNSSźŲ˿
	01:4ߴӷʽʽ(Ĭֵ)NSS
	1x:4ߵʽNSSźűһŲNSSMD0ֵ

 b1(TXBMT):ݴձ־λ
	µݱд뻺ʱλ㣬ͻеݱ͵SPIλĴʱλ1

 b0(SPIEN):SPIʹλ
	0:ֹSPI
	1:ʹSPI

*/
sfr SPICTL = 0xF8;
sbit SPIF = SPICTL ^ 7;
sbit WCOL = SPICTL ^ 6;
sbit MODF = SPICTL ^ 5;
sbit RXOVRN = SPICTL ^ 4;

sbit TXBMT = SPICTL ^ 1;
sbit SPIEN = SPICTL ^ 0;

/*
DISP_CFG
 b7 - b2:NA

 b1(DISP_MOD):LCD/LEDѡ
   0:ѡLCD
   1:ѡLED

 b0(LED_MOD):LED
   0:
   1:
*/
sfr DISP_CFG = 0xFD;
#define DISP_MODE 0X02
#define LED_MODE 0X01

/*
DISP_EN
 b7(DISP_ON):LED/LCDʹλ
   0:DISABLE
   1:ENABLE

  b6:NA

  b5 - b3(DUTY[2:0]):LED/LCD DUTY
   LCD:
	   000:1/3 duty
	   001:1/4 duty
	   010:1/5 duty
	   011:1/6 duty
	   100:1/8 duty
	LED:
	   xx0:1/4 duty
	   xx1:1/8 duty
  b2 - b0(LCD_FREQ[2:0]):			// ȷǷLCD AND LED
*/
sfr DISP_EN = 0xFE;
#define DISP_ON 0X80
#define LCD_DUTY_1_3 0X00
#define LCD_DUTY_1_4 0X08
#define LCD_DUTY_1_5 0X10
#define LCD_DUTY_1_6 0X18
#define LCD_DUTY_1_8 0X20

#define LED_DUTY_1_4 0X00
#define LED_DUTY_1_8 0X08

/*д0X090X26;д0X12*/
sfr CLKEY = 0xFF;

//-----------------------------------------------------------------------------
// Interrupt Priorities
//-----------------------------------------------------------------------------

#define INTERRUPT_INT 0 // External Interrupt 0

#define INTERRUPT_PORT 2   // Port Interrupt
#define INTERRUPT_TIMER1 3 // Timer1 Overflow
#define INTERRUPT_UART 4   // UART
#define INTERRUPT_SPI 5	   // SPI
#define INTERRUPT_ADC 6	   // ADC
#define INTERRUPT_TIMER2 7 // TIMER2

#define INTERRUPT_TIMER3 9	// TIMER3
#define INTERRUPT_RTC 10	// RTC
#define INTERRUPT_TIMER4 11 // TIMER4
#define INTERRUPT_CS 12		// CS
#define INTERRUPT_I2C 13	// I2C
#define INTERRUPT_MCD 14	// MCD

/*******************YS67F9XXX Touch*************************************/

#define SCAN_EN 0X1100
#define CS0EN 0X80	   /*1õɨ裬0ֹɨ裬ɨнֹ0*/
#define CS0START 0X40  /*1ʹֶɨ裬0ֶֹɨ;ֶɨģʽЧ*/
#define SCAN_MODE 0X20 /*1Զɨ裬0ֶɨ*/
#define RAM_EN 0X10	   /*1CS16ƴRAM0MCUƴRAM*/
#define RAM_MODE 0X08  /*1MCUǷȡݣɨС0MCUûжߵݴ ɨ費*/

#define IE_EOS 0X02 /*1ͨɨ󣬲жϡ0ͨɨ󲻲ж*/
#define IE_CMP 0X01 /*1Զɨģʽʱдж*/

#define SCAN_STATUS 0X1101

#define CS0PME 0X10		 /*1ǰһɨPIN NOISE*/
#define MULT_RESULT 0X08 /*1ȫͨɨ⵽д*/
#define CS0BUTY 0X04	 /*1ɨڽУ0ɨûн*/
#define CS0E0S 0X02		 /*ͨɨ1´ɨ迪ʼ0*/
#define CS0CMPF 0X01	 /*1ɨһͨд*/

#define SCAN_CFG 0X1102
#define CS0CMPEN 0X80 /*1ֱȽʹ*/
#define CS0MCEN 0X40  /*1ʹȫͨɨ*/

#define CS0CR_12BIT 0X00 /*12bitαƽ*/
#define CS0CR_13BIT 0X10 /*13bitαƽ*/
#define CS0CR_14BIT 0X20 /*14bitαƽ*/
#define CS0CR_16BIT 0X30 /*16bitαƽ*/

#define CS0ACU_1SAMPLE 0X00	 /*1ɨ*/
#define CS0ACU_4SAMPLE 0X02	 /*4ɨ*/
#define CS0ACU_8SAMPLE 0X04	 /*8ɨ*/
#define CS0ACU_16SAMPLE 0X06 /*16ɨ*/
#define CS0ACU_32SAMPLE 0X08 /*32ɨ*/
#define CS0ACU_64SAMPLE 0X09 /*64ɨ*/

#define MULT_POL 0X01 /*ֱͨȽѡ0Ƚϣ1Ƚ*/

#define CH_RESULT 0X1103 /*ɨȽϽ*/

#define CH_RESULTH 0X1103
#define CH_RESULTL 0X1104

#define CH_MASK 0X1105 /*ͨMASK*/

#define CH_MASKH 0X1105
#define CH_MASKL 0X1106

#define SCAN_TMR 0X1107 /*Զɨʱ*/

#define SCAN_TMRH 0X1107
#define SCAN_TMRL 0X1108

#define CH_POL 0X1109 /*ֱͨȽѡ0Ƚϣ1Ƚ*/

#define CH_POLH 0X1109
#define CH_POLL 0X110A

#define TH_CFG0 0X110B
#define TH_UPD_EN 0X80	/*1Զ*/
#define TH_MOD 0X40		/*޸ۼӴ0:8Σ1:16*/
#define TH_FORCE 0X20	/*1ǿƸһ*/
#define TH_ACC_RST 0X10 /*0: Զʱtouchtouch_dead_areaۼۼӲ㣬֮ۼӡ \
1: Զʱtouchtouch_dead_area ۼ㡣֮󣬴㿪ʼۼ                                      \
*/

#define TH_CFG1 0X110C
#define TH_GAP1 0X00
#define TH_GAP2 0X10
#define TH_GAP3 0X20
#define TH_GAP4 0X30
#define TH_GAP5 0X40
#define TH_GAP6 0X50
#define TH_GAP7 0X60
#define TH_GAP8 0X70
#define TH_GAP9 0X80
#define TH_GAP10 0X90
#define TH_GAP11 0XA0
#define TH_GAP12 0XB0
#define TH_GAP13 0XC0
#define TH_GAP14 0XD0
#define TH_GAP15 0XE0
#define TH_GAP16 0XF0

#define PIN_MON 0X110D

#define CS_ADJ0 0X110E
#define CS_ADJ1 0X110F
#define CS_ADJ2 0X1110

#define CS_TST 0X1111

#define CS_CAP_BASE 0X1000
#define CS_CAP_CH0 0X1000
#define CS_CAP_CH1 0X1002
#define CS_CAP_CH2 0X1004
#define CS_CAP_CH3 0X1006
#define CS_CAP_CH4 0X1008
#define CS_CAP_CH5 0X100A
#define CS_CAP_CH6 0X100C
#define CS_CAP_CH7 0X100E
#define CS_CAP_CH8 0X1010
#define CS_CAP_CH9 0X1012
#define CS_CAP_CH10 0X1014
#define CS_CAP_CH11 0X1016
#define CS_CAP_CH12 0X1018
#define CS_CAP_CH13 0X101A
#define CS_CAP_CH14 0X101C
#define CS_CAP_CH15 0X101E
#define CS_CAP_MULT 0X1020

#define CS_TH_BASE 0X1022
#define CS_TH_CH0 0X1022
#define CS_TH_CH1 0X1024
#define CS_TH_CH2 0X1026
#define CS_TH_CH3 0X1028
#define CS_TH_CH4 0X102A
#define CS_TH_CH5 0X102C
#define CS_TH_CH6 0X102E
#define CS_TH_CH7 0X1030
#define CS_TH_CH8 0X1032
#define CS_TH_CH9 0X1034
#define CS_TH_CH10 0X1036
#define CS_TH_CH11 0X1038
#define CS_TH_CH12 0X103A
#define CS_TH_CH13 0X103C
#define CS_TH_CH14 0X103E
#define CS_TH_CH15 0X1040
#define CS_TH_MULT 0X1042

#define CS_DIF_BASE 0X1044
#define CS_DIF_CH0 0X1044
#define CS_DIF_CH1 0X1046
#define CS_DIF_CH2 0X1048
#define CS_DIF_CH3 0X104A
#define CS_DIF_CH4 0X104C
#define CS_DIF_CH5 0X104E
#define CS_DIF_CH6 0X1050
#define CS_DIF_CH7 0X1052
#define CS_DIF_CH8 0X1054
#define CS_DIF_CH9 0X1056
#define CS_DIF_CH10 0X1058
#define CS_DIF_CH11 0X105A
#define CS_DIF_CH12 0X105C
#define CS_DIF_CH13 0X105E
#define CS_DIF_CH14 0X1060
#define CS_DIF_CH15 0X1062
#define CS_DIF_MULT 0X1064

/*
#define CS_CH0				0X00
#define CS_CH1				0X01
#define CS_CH2				0X02
#define CS_CH3				0X03
#define CS_CH4				0X04
#define CS_CH5				0X05
#define CS_CH6				0X06
#define CS_CH7				0X07
#define CS_CH8				0X08
#define CS_CH9				0X09
#define CS_CH10				0X0A
#define CS_CH11				0X0B
#define CS_CH12				0X0C
#define CS_CH13				0X0D
#define CS_CH14				0X0E
#define CS_CH15				0X0F
//*/

#define CS_BIT_CH0 0X0001
#define CS_BIT_CH1 0X0002
#define CS_BIT_CH2 0X0004
#define CS_BIT_CH3 0X0008
#define CS_BIT_CH4 0X0010
#define CS_BIT_CH5 0X0020
#define CS_BIT_CH6 0X0040
#define CS_BIT_CH7 0X0080
#define CS_BIT_CH8 0X0100
#define CS_BIT_CH9 0X0200
#define CS_BIT_CH10 0X0400
#define CS_BIT_CH11 0X0800
#define CS_BIT_CH12 0X1000
#define CS_BIT_CH13 0X2000
#define CS_BIT_CH14 0X4000
#define CS_BIT_CH15 0X8000

#define REG_R(addr) (*((u8 xdata *)addr))
#define REG16_R(addr) (*((u16 xdata *)addr))

#define REG_W(addr, value)           \
	do                               \
	{                                \
		*((u8 xdata *)addr) = value; \
	} while (0)
#define REG16_W(addr, value)          \
	do                                \
	{                                 \
		*((u16 xdata *)addr) = value; \
	} while (0)

#endif
